program main
implicit none

    integer, parameter::lowest = 1
    integer, parameter::highest = 69
    integer, parameter::length = 5
    
    integer, dimension(length)::values
    character::cmd
    integer::i
    
    interface
        subroutine init_lucky_numbers
        end subroutine init_lucky_numbers
    end interface
    
    interface
        subroutine lucky_numbers(v, l, h)
        integer, dimension(:), intent(inout)::v
        integer, intent(in)::l, h
        end subroutine lucky_numbers
    end interface
    
    call init_lucky_numbers()
    
    write(*, '(A)', ADVANCE='NO') "Press [ENTER] to generate or [Q] and [ENTER] to quit: "
    read(*,'(A1)') cmd
    
    do while(cmd .NE. 'Q' .AND. cmd .NE. 'q')
        call lucky_numbers(values, lowest, highest)
        
        write(*, '(2X,5(I2,4X))') (values(i),i=1,length)
        
        write(*, '(A)', ADVANCE='NO') "Press [ENTER] to generate or [Q] and [ENTER] to quit: "
        read(*,'(A1)') cmd
    end do
    
    write (*,*) " "
    
end program main
